;; After compiled:
;; Run as: qemu-system-i386 -kernel kernel
;; Kernel is loaded at 0x100000 (above 1 MB)

bits 32
;;org 0x100000 ;;Only with -f bin

SECTION .text
	;; Header for multiboot GRUB:
	align 4
	;; Magin number:
	dd 0x1badb002
	;; Header flags:
	dd 0x00
	;; Header checksum:
	dd - (0x1badb002 + 0x00)
	
	global _start
	extern kmain

_start:
	;cli
	;xor ax, ax
	;int 16h
	;mov ah, 4ch
	;int 21h
	cli
	;; Run main kernel loop:
	call  kmain
	
	;; Cursor OFF
	push ax
	push dx
	mov al, 0x0a
	mov dx, 0x03d4
	out dx, al
	mov dx, 0x03d5
	in al, dx
	or ax, 0010000b
	out dx, ax
	pop dx
	pop ax
	;; Cursor OFF

	;; Print White Character
	;mov edx, 0xb8000
	;mov al, 'a'
	;mov ah, 0x07
	;mov [edx], ax
	;; Print White Character

	;; Read scancode:
	;mov edx, 0xb8000
powt:
	;in al, 60h
	;mov ah, 0x07
	;mov [edx], ax	
	;jmp powt
	;; Read scancode

	;push ss
	;push sp
	;xor ax, ax
	;mov ss, ax
	;mov sp, 0x0000
	
	;; Get key:
	;mov ah, 0x00
	;int 16h
	;; Print key:
	;mov ah, 0x0e
	;int 10h

	;pop sp
	;pop ss

	hlt
	dd 0xabababab